<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.dk.mdm.mapper.core.PostMapper">

    <!-- 通用设置 -->
    <!-- 通用查询列 -->
    <sql id="Base_Column_List">
        post_id
        , post_name, display_no, remarks, flg_valid, fty_id, op_create_time, op_create_user_id, op_update_time, op_update_user_id, op_app_code, op_timestamp, op_db_user
    </sql>

    <!-- 通用查询映射结果 -->
    <resultMap id="BaseResultMap" type="com.dk.mdm.model.response.core.PostResponse">
        <id column="post_id" property="postId"/>
        <result column="post_name" property="postName"/>
        <result column="display_no" property="displayNo"/>
        <result column="remarks" property="remarks"/>
        <result column="flg_valid" property="flgValid"/>
        <result column="fty_id" property="ftyId"/>
        <result column="op_create_time" property="opCreateTime"
                typeHandler="com.dk.common.infrastructure.handler.TimestampTypeHandler"/>
        <result column="op_create_user_id" property="opCreateUserId"/>
        <result column="op_update_time" property="opUpdateTime"
                typeHandler="com.dk.common.infrastructure.handler.TimestampTypeHandler"/>
        <result column="op_update_user_id" property="opUpdateUserId"/>
        <result column="op_app_code" property="opAppCode"/>
        <result column="op_timestamp" property="opTimestamp"
                typeHandler="com.dk.common.infrastructure.handler.TimestampTypeHandler"/>
        <result column="op_db_user" property="opDbUser"/>
    </resultMap>

    <!-- 通用条件列 -->
    <sql id="Condition">
        <where>
            <if test="postName != null and postName != ''">
                AND position (#{postName} in post_name) >0
            </if>
            <if test="displayNo != null">
                AND display_no = #{displayNo}
            </if>
            <if test="remarks != null and remarks != ''">
                AND remarks = #{remarks}
            </if>
            <if test="flgValid != null">
                AND flg_valid = #{flgValid}
            </if>
            <if test="ftyId != null">
                AND fty_id = #{ftyId}
            </if>
            <if test="opCreateTime != null">
                AND op_create_time = #{opCreateTime}
            </if>
            <if test="opCreateUserId != null">
                AND op_create_user_id = #{opCreateUserId}
            </if>
            <if test="opUpdateTime != null">
                AND op_update_time = #{opUpdateTime}
            </if>
            <if test="opUpdateUserId != null">
                AND op_update_user_id = #{opUpdateUserId}
            </if>
            <if test="opAppCode != null and opAppCode != ''">
                AND op_app_code = #{opAppCode}
            </if>
            <if test="opTimestamp != null">
                AND op_timestamp = #{opTimestamp}
            </if>
            <if test="opDbUser != null and opDbUser != ''">
                AND op_db_user = #{opDbUser}
            </if>
            <if test="flgValidList != null and flgValidList.size()>0">
                AND flg_valid =
                any(#{flgValidList, typeHandler=BooleanListTypeHandler})
            </if>
        </where>
    </sql>

    <sql id="idsForeach">
        <!-- 根据主键postId批量操作 -->
        WHERE post_id in
        <foreach collection="ids" index="index" item="item" separator="," open="(" close=")">
            #{item}
        </foreach>
    </sql>

    <!-- 查询表t_post，（条件查询+分页）列表 -->
    <select id="selectByCond" resultMap="BaseResultMap">
        SELECT
        <include refid="Base_Column_List"/>
        FROM core.t_post
        <include refid="Condition"/>
        ORDER BY flg_valid DESC , display_no
        <if test="pageSize != null and currentPage != null and pageSize != 0 and currentPage != 0">
            limit #{end} offset #{start}
        </if>
    </select>

    <!-- 查询表t_post，（条件查询）个数 -->
    <select id="countByCond" resultType="Long">
        SELECT
        count(1)
        FROM core.t_post
        <include refid="Condition"/>
    </select>

</mapper>
